<?php
session_start();
// Change these
define('API_KEY',     $_SESSION['linkedin_app_id']);
define('API_SECRET',  $_SESSION['linkedin_app_secret']);
// You must pre-register your redirect_uri at https://www.linkedin.com/secure/developer
define('REDIRECT_URI', $_SESSION['pm_social_encore_linkedin_login']);
define('SCOPE', 'w_share r_basicprofile r_emailaddress' );

// OAuth 2 Control Flow
if (isset($_GET['error'])) {
    // LinkedIn returned an error
    print $_GET['error'] . ': ' . $_GET['error_description'];
    exit;
} elseif (isset($_GET['code'])) {
    // User authorized your application
    if ($_SESSION['linkedin_state'] == $_GET['state']) {
        // Get token so you can make API calls
        getAccessToken();
    } else {
        // CSRF attack? Or did you mix up your states?
        exit;
    }
} else { 
    if ((empty($_SESSION['linkedin_expires_at'])) || (time() > $_SESSION['linkedin_expires_at'])) {
        // Token has expired, clear the state
        //$_SESSION = array();
		unset($_SESSION['linkedin_access_token']);
		unset($_SESSION['linkedin_expires_at']);
		unset($_SESSION['linkedin_state']);
    }
    if (empty($_SESSION['linkedin_access_token'])) {
        // Start authorization process
        getAuthorizationCode();
    }
}

if(isset($_SESSION['linkedin_access_token'])) {
header("Location: {$_SESSION['pm_social_encore_settings_url']}");
}
exit;
 
function getAuthorizationCode() {
    $params = array(
        'response_type' => 'code',
        'client_id' => API_KEY,
        'scope' => SCOPE,
        'state' => uniqid('', true), // unique long string
        'redirect_uri' => REDIRECT_URI,
    );
 
    // Authentication request
    $url = 'https://www.linkedin.com/uas/oauth2/authorization?' . http_build_query($params);
     
    // Needed to identify request when it returns to us
    $_SESSION['linkedin_state'] = $params['state'];
 
    // Redirect user to authenticate
    header("Location: $url");
    exit;
}
     
function getAccessToken() {
    $params = array(
        'grant_type' => 'authorization_code',
        'client_id' => API_KEY,
        'client_secret' => API_SECRET,
        'code' => $_GET['code'],
        'redirect_uri' => REDIRECT_URI,
    );
     
    // Access Token request
    $url = 'https://www.linkedin.com/uas/oauth2/accessToken?' . http_build_query($params);
     
    // Tell streams to make a POST request
    $context = stream_context_create(
        array('http' => 
            array('method' => 'POST',
            )
        )
    );
 
    // Retrieve access token information
    $response = file_get_contents($url, false, $context);
 
    // Native PHP object, please
    $token = json_decode($response);
 
    // Store access token and expiration time
    $_SESSION['linkedin_access_token'] = $token->access_token; // guard this! 
    $_SESSION['expires_in']   = $token->expires_in; // relative time (in seconds)
    $_SESSION['linkedin_expires_at']   = time() + $_SESSION['expires_in']; // absolute time
     
    return true;
}
