<?php 
add_action( 'add_meta_boxes', 'pm_social_encore_add_custom_box' );
function pm_social_encore_add_custom_box() {
	add_meta_box(
		'pm_social_encore_mbox',
		__( PM_SOCIAL_ENCORE_PLUGIN_NAME.' Schedules' , 'pm-social-encore' ),
		'pm_social_encore_inner_custom_box',
		'social_encore', 'normal' , 'core'
	);
	
	add_meta_box(
		'pm_social_encore_logs',
		__( PM_SOCIAL_ENCORE_PLUGIN_NAME.' Logs' , 'pm-social-encore' ),
		'pm_social_encore_logs_callback',
		'social_encore', 'normal' , 'core'
	);
}



function pm_social_encore_inner_custom_box( $post ) {
	
	wp_nonce_field( plugin_basename( __FILE__ ), 'pm_social_encore_noncename' );
	//$allow_auto_end = (get_option(PM_SOCIAL_ENCORE_SETTINGS_OPTION.'_auto_end') ? true : false);
	wp_enqueue_script( 'jquery-ui-datepicker' );
	wp_enqueue_script( 'jquery-ui-slider' );
	wp_register_style( 'jquery-ui-styles','https://ajax.googleapis.com/ajax/libs/jqueryui/1.11.2/themes/smoothness/jquery-ui.css', '', PM_SOCIAL_ENCORE_VERSION, 'all'  );
	wp_enqueue_style( 'jquery-ui-styles' );
	
	wp_enqueue_style( 'pm-se-admin-chosen-style', PM_SOCIAL_ENCORE_DIR.'modules/libs/chosen/chosen.min.css', '', PM_SOCIAL_ENCORE_VERSION, 'all' );
	wp_enqueue_script( 'pm-se-admin-chosen-script', PM_SOCIAL_ENCORE_DIR.'modules/libs/chosen/chosen.jquery.min.js', '', PM_SOCIAL_ENCORE_VERSION );
	
	wp_enqueue_style( 'pm-se-admin-timepicker-style', PM_SOCIAL_ENCORE_DIR.'modules/libs/timepicker/jquery-ui-timepicker-addon.css', '', PM_SOCIAL_ENCORE_VERSION, 'all' );
	wp_enqueue_script( 'pm-se-admin-timepicker-script', PM_SOCIAL_ENCORE_DIR.'modules/libs/timepicker/jquery-ui-timepicker-addon.js', array('jquery'), PM_SOCIAL_ENCORE_VERSION, true );
	
	wp_enqueue_script( 'pm-se-admin-script', PM_SOCIAL_ENCORE_DIR.'modules/src/js/pm-se.js', array('jquery'), PM_SOCIAL_ENCORE_VERSION, true );
	
	$se_enabled = (get_post_meta($post->ID, '_pm_se_enabled', true) ? get_post_meta($post->ID, '_pm_se_enabled', true) : 'yes');
	$se_type = (get_post_meta($post->ID, '_pm_se_type', true) ? get_post_meta($post->ID, '_pm_se_type', true) : 'bet');
	$se_post_type = (get_post_meta($post->ID, '_pm_se_post_type', true) ? get_post_meta($post->ID, '_pm_se_post_type', true) : '');
	
	$se_date_a = (get_post_meta($post->ID, '_pm_se_date_a', true) ? get_post_meta($post->ID, '_pm_se_date_a', true) : '');
	$se_date_b = (get_post_meta($post->ID, '_pm_se_date_b', true) ? get_post_meta($post->ID, '_pm_se_date_b', true) : '');
	$se_date_initial = (get_post_meta($post->ID, '_pm_se_date_initial', true) ? get_post_meta($post->ID, '_pm_se_date_initial', true) : '');
	$se_interval = (get_post_meta($post->ID, '_pm_se_interval', true) ? get_post_meta($post->ID, '_pm_se_interval', true) : 0);
	
	$se_social = (get_post_meta($post->ID, '_pm_se_social', true) ? get_post_meta($post->ID, '_pm_se_social', true) : array());
	$se_specific_post = (get_post_meta($post->ID, '_pm_se_specific_post', true) ? get_post_meta($post->ID, '_pm_se_specific_post', true) : '');
	
	$se_source = (get_post_meta($post->ID, '_pm_se_source', true) ? get_post_meta($post->ID, '_pm_se_source', true) : 'random');
	
	$se_allow_duplicate = (get_post_meta($post->ID, '_pm_se_allow_duplicate', true) ? get_post_meta($post->ID, '_pm_se_allow_duplicate', true) : '');
	
	
	
	$style_blocked = " style='display:block;' ";
	$style_hidden = " style='display:none;' ";
	?>
	<div id="social_encore_post_meta">
		<div id="pm_se_enabled_wrapper" class="pm_se_wrapper">
			<h4><?php esc_html(_e( 'Social Encore.', 'pm-social-encore' )); ?></h4>
			<input <?php print ($se_enabled == 'yes' ? 'checked' : ''); ?> type="checkbox" name="_pm_se_enabled" id="pm_se_enabled" value="yes" />
			<label for="pm_se_enabled"><?php esc_html(_e( 'Enable/Disable this Social Encore.', 'pm-social-encore' )); ?></label><br />
		</div>
		<hr />
		
		<div id="pm_se_source_wrapper" class="pm_se_wrapper">			
			<h4><?php esc_html(_e( 'Social Encore Source.', 'pm-social-encore' )); ?></h4>
			<p class="description"><?php esc_html(_e( 'Select if you want to set a Random Post or a Specific Post', 'pm-social-encore' )); ?></p>
			<input <?php print ($se_source == 'random' ? 'checked' : ''); ?> type="radio" name="_pm_se_source" value="random" id="pm_se_source_random"  class="pm_se_type"> <label for="pm_se_source_random"><?php esc_html(_e( 'Random Source', 'pm-social-encore' )); ?></label><br />
			<input <?php print ($se_source == 'specific' ? 'checked' : ''); ?> type="radio" name="_pm_se_source" value="specific" id="pm_se_source_specific" class="pm_se_type"> <label for="pm_se_source_specific"><?php esc_html(_e( 'Specific Source', 'pm-social-encore' )); ?></label>	
		</div>
		<hr />
	<div id="social_encore_post_meta_specific" <?php print ($se_source == 'specific' ? $style_blocked : $style_hidden); ?>>	
		<div id="pm_se_specific_post_wrapper" class="pm_se_wrapper">
			<h4><?php esc_html(_e( 'Step 1. Define Specific Post', 'pm-social-encore' )); ?></h4>
			<p class="description"><?php esc_html(_e( 'Enter the Post ID of the Post you want to Auto Publish', 'pm-social-encore' )); ?><br />
			<?php esc_html(_e( 'You can only enter 1 Post ID', 'pm-social-encore' )); ?><br />			
			</p>
			<input type="number" min="0" name="_pm_se_specific_post" id="pm_se_specific_post" value="<?php print $se_specific_post; ?>" />
		</div>
		<hr />
	</div>
	<div id="social_encore_post_meta_random"  <?php print ($se_source == 'random' ? $style_blocked : $style_hidden); ?>>	
		<div id="pm_se_allow_duplicate_wrapper">
			<h4><?php esc_html(_e( 'Random Type Settings', 'pm-social-encore' )); ?></h4>
			<input <?php print ($se_allow_duplicate == 'yes' ? 'checked' : ''); ?> type="checkbox" name="_pm_se_allow_duplicate" id="pm_se_allow_duplicate" value="yes" />
			<label for="pm_se_allow_duplicate"><?php esc_html(_e( 'Allow Re-Publishing of already published post by this schedule', 'pm-social-encore' )); ?></label><br />
			<p class="description"><?php esc_html(_e( 'This setting only applies to this Schedule.', 'pm-social-encore' )); ?><br />
		</div>
		<div id="pm_se_type_wrapper">
			<h4><?php esc_html(_e( 'Step 1. Select Post Type', 'pm-social-encore' )); ?></h4>
			<p class="description"><?php esc_html(_e( 'Select the post type you want.', 'pm-social-encore' )); ?></p>
			<div class="pm_social_encore_label_wrapper">
				<select name="_pm_se_post_type">
					<option value="" style="display: none;"  default><?php esc_html(_e('Post Type', 'pm-social-encore')); ?></option>
					<option <?php print ($se_post_type == 'post' ? 'selected': ''); ?> value="post"><?php esc_html(printf(__( '%s', 'pm-social-encore' ), 'Post')); ?></option>
					<option <?php print ($se_post_type == 'page' ? 'selected': ''); ?> value="page"><?php esc_html(printf(__( '%s', 'pm-social-encore' ), 'Page')); ?></option>
					<?php
					$args = array(
						'public' => true,
						'_builtin' => false
					);
					$post_types = get_post_types($args,'objects','and');
					foreach ( $post_types  as $post_type ): 
					?>
						<option <?php print ($se_post_type == $post_type->name ? 'selected': ''); ?>  value="<?php $post_type->name; ?>"><?php esc_html(printf(__( '%s', 'pm-social-encore' ), $post_type->labels->name)); ?></option>
					<?php endforeach; ?>
				</select>
			</div>
		</div>
		<hr />
		<div id="pm_se_type_wrapper">
			<h4><?php esc_html(_e( 'Step 2. Posting Range', 'pm-social-encore' )); ?></h4>
			<p class="description"><?php esc_html(_e( 'Select type of schedule.', 'pm-social-encore' )); ?></p>
			<input <?php print ($se_type == 'bet' ? 'checked' : ''); ?> type="radio" name="_pm_se_type" value="bet" id="pm_se_type_bet"  class="pm_se_type"> <label for="pm_se_type_bet"><?php esc_html(_e( 'Between two dates', 'pm-social-encore' )); ?></label><br />
			<input <?php print ($se_type == 'before' ? 'checked' : ''); ?> type="radio" name="_pm_se_type" value="before" id="pm_se_type_before" class="pm_se_type"> <label for="pm_se_type_before"><?php esc_html(_e( 'Before specific date', 'pm-social-encore' )); ?></label><br />
			<input <?php print ($se_type == 'after' ? 'checked' : ''); ?> type="radio" name="_pm_se_type" value="after" id="pm_se_type_after"  class="pm_se_type"> <label for="pm_se_type_after"><?php esc_html(_e( 'After specific date', 'pm-social-encore' )); ?></label>
		</div>
		<div id="pm_se_date_a_wrapper" class="pm_se_wrapper">
			<label for="pm_se_date_a"><?php esc_html(_e( 'Date', 'pm-social-encore' )); ?></label>
			<input type="text" name="_pm_se_date_a" id="pm_se_date_a" placeholder="yyyy-mm-dd" value="<?php print $se_date_a; ?>" />
		</div>
		<div <?php print ($se_type == 'bet' ? $style_blocked : $style_hidden); ?> id="pm_se_date_b_wrapper" class="pm_se_wrapper">
				<label for="pm_se_date_b"><?php esc_html(_e( 'to Date', 'pm-social-encore' )); ?></label>
				<input type="text" name="_pm_se_date_b" id="pm_se_date_b" placeholder="yyyy-mm-dd" value="<?php print $se_date_b; ?>" />
		</div>
		<hr />
	</div>
	
		<div id="pm_se_date_initial_wrapper" class="pm_se_wrapper">
			<h4><?php esc_html(_e( 'Step 3. First Posting Schedule', 'pm-social-encore' )); ?></h4>
			<p class="description"><?php esc_html(_e( 'Set the Date and Time', 'pm-social-encore' )); ?><br />
			<strong><?php esc_html(_e( 'Server time is: ', 'pm-social-encore' )); ?></strong> <?php print date_i18n('F j, Y @ H:i', time(), false); ?> - UTC
			</p>
			<label for="pm_se_date_initial"><?php esc_html(_e( 'Initial Schedule', 'pm-social-encore' )); ?></label>
			<input type="text" name="_pm_se_date_initial" id="pm_se_date_initial" placeholder="mm/dd/yyyy HH:mm"  value="<?php print $se_date_initial; ?>" />
		</div>
		<hr />
		
		<div id="pm_se_interval_wrapper" class="pm_se_wrapper">
			<h4><?php esc_html(_e( 'Step 4. Repeatable', 'pm-social-encore' )); ?></h4>
			<p class="description"><?php esc_html(_e( 'Set the Interval in minutes.', 'pm-social-encore' )); ?><br />
			<?php esc_html(_e( 'Set Interval to 0 if not repeatable', 'pm-social-encore' )); ?><br />
			<?php esc_html(_e( 'You can visit this site to convert days to minutes. ', 'pm-social-encore' )); ?> <a target="_blank" href="http://www.easysurf.cc/utime.htm#d24m">http://www.easysurf.cc/utime.htm#d24m</a>
			
			</p>
			<input type="number" min="0" name="_pm_se_interval" id="pm_se_interval" value="<?php print $se_interval; ?>" />
		</div>
		<hr />
		
		<div id="pm_se_social_wrapper" class="pm_se_wrapper">
			<h4><?php esc_html(_e( 'Step 5. Select where to Post', 'pm-social-encore' )); ?></h4>
			<p class="description"><?php esc_html(_e( 'Select Site on where you want to post.', 'pm-social-encore' )); ?><br />
			<?php esc_html(_e( 'Make sure the Selected Social site is configured properly.', 'pm-social-encore' )); ?>
			</p>
			<input <?php print (in_array('facebook', $se_social) ? 'checked' : ''); ?> type="checkbox" name="_pm_se_social[]" id="pm_se_social_facebook" value="facebook" />
			<label for="pm_se_social_facebook"><?php esc_html(_e( 'Facebook', 'pm-social-encore' )); ?></label><br />
			
			<input <?php print (in_array('twitter', $se_social) ? 'checked' : ''); ?>  type="checkbox" name="_pm_se_social[]" id="pm_se_social_twitter" value="twitter" />
			<label for="pm_se_social_twitter"><?php esc_html(_e( 'Twitter', 'pm-social-encore' )); ?></label><br />
			
			<input <?php print (in_array('linkedin', $se_social) ? 'checked' : ''); ?>  type="checkbox" name="_pm_se_social[]" id="pm_se_social_gplus" value="linkedin" />
			<label for="pm_se_social_gplus"><?php esc_html(_e( 'LinkedIn', 'pm-social-encore' )); ?></label><br />
		</div>
		<hr />
	</div>
	<?php
}

add_action( 'save_post', 'pm_social_encore_save_postdata' );
function pm_social_encore_save_postdata( $post_id ) {
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	  return;
	if ( !empty( $_POST['pm_social_encore_noncename'] ) && !wp_verify_nonce( $_POST['pm_social_encore_noncename'], plugin_basename( __FILE__ ) ) )
	  return;
	if ( !empty($_POST['post_type']) && 'page' == $_POST['post_type'] ) 
	{
	if ( !current_user_can( 'edit_page', $post_id ) )
		return;
	}
	else
	{
	if ( !current_user_can( 'edit_post', $post_id ) )
		return;
	}
	
	$se_enabled = (isset($_POST['_pm_se_enabled']) ? $_POST['_pm_se_enabled'] : 'no');
	update_post_meta( $post_id, '_pm_se_enabled', $se_enabled);
	
	$se_type = (isset($_POST['_pm_se_type']) ? esc_html($_POST['_pm_se_type']) : '');
	update_post_meta( $post_id, '_pm_se_type', $se_type);
	
	$se_post_type = (isset($_POST['_pm_se_post_type']) ? esc_html($_POST['_pm_se_post_type']) : '');
	update_post_meta( $post_id, '_pm_se_post_type', $se_post_type);
	
	$se_date_a = (isset($_POST['_pm_se_date_a']) ? esc_html($_POST['_pm_se_date_a']) : '');
	update_post_meta( $post_id, '_pm_se_date_a', $se_date_a);
	
	$se_date_b = (isset($_POST['_pm_se_date_b']) ? esc_html($_POST['_pm_se_date_b']) : '');
	update_post_meta( $post_id, '_pm_se_date_b', $se_date_b);
	
	$se_date_initial = (isset($_POST['_pm_se_date_initial']) ? esc_html($_POST['_pm_se_date_initial']) : '');
	update_post_meta( $post_id, '_pm_se_date_initial', $se_date_initial);
	
	$se_interval = (isset($_POST['_pm_se_interval']) ? esc_html($_POST['_pm_se_interval']) : '');
	update_post_meta( $post_id, '_pm_se_interval', $se_interval);
	
	$se_social = (isset($_POST['_pm_se_social']) ? $_POST['_pm_se_social'] : '');
	update_post_meta( $post_id, '_pm_se_social', $se_social);
	
	$se_specific_post = (isset($_POST['_pm_se_specific_post']) ? esc_html($_POST['_pm_se_specific_post']) : '');
	update_post_meta( $post_id, '_pm_se_specific_post', $se_specific_post);
	
	$se_source = (isset($_POST['_pm_se_source']) ? esc_html($_POST['_pm_se_source']) : '');
	update_post_meta( $post_id, '_pm_se_source', $se_source);
	
	$se_allow_duplicate = (isset($_POST['_pm_se_allow_duplicate']) ? $_POST['_pm_se_allow_duplicate'] : '');
	update_post_meta( $post_id, '_pm_se_allow_duplicate', $se_allow_duplicate);
	
	//Clear and Reset Cron Schedule
	pm_social_encore_schedule_event($post_id, 'save');
	
}



/*
	* pm_social_encore_logs_callback
*/

function pm_social_encore_logs_callback($post) {
	$logs = pm_social_encore_query_logs($post->ID);
	
	?>
	<div id="social_encore_post_logs_wrapper">
		<table width="100%" border="1">
			<thead>
				<tr>
					<th><?php esc_html(_e( 'Post ID', 'pm-social-encore' )); ?></th>
					<th><?php esc_html(_e( 'Social', 'pm-social-encore' )); ?></th>
					<th><?php esc_html(_e( 'Time', 'pm-social-encore' )); ?></th>
					<th><?php esc_html(_e( 'Status', 'pm-social-encore' )); ?></th>
				</tr>
			</thead>
			<tbody>
			<?php foreach($logs as $log): 
			$mysqldate = strtotime( $log->time );
			$wp_format = get_option('date_format'). ' ' . get_option('time_format');
			$log_date = date( $wp_format, $mysqldate );
			?>
				<tr>
					<td><?php esc_html(printf(__( '%s', 'pm-social-encore' ), $log->postid)); ?></td>
					<td><?php esc_html(printf(__( '%s', 'pm-social-encore' ), $log->social)); ?></td>
					<td><?php esc_html(printf(__( '%s', 'pm-social-encore' ), $log_date)); ?></td>
					<td><?php esc_html(printf(__( '%s', 'pm-social-encore' ), $log->status)); ?></td>
				</tr>
			<?php endforeach; ?>
			</tbody>
		</table>
	</div>
<?php
}

?>