<?php 
add_action('init', 'pm_social_encore_start_session', 1);
function pm_social_encore_start_session() {
    if(!session_id()) {
        session_start();
    }
	$_SESSION['pm_social_encore_settings_url'] = pm_social_encore_settings_url();
	$_SESSION['pm_social_encore_linkedin_login'] = PM_SOCIAL_ENCORE_DIR.'modules/libs/login/linkedin-login.php';
}

function pm_social_encore_register_settings_page() {
	add_menu_page(esc_html(sprintf(__( '%s ', 'pm-social-encore' ), PM_SOCIAL_ENCORE_PLUGIN_NAME)), esc_html(sprintf(__( '%s Settings', 'pm-social-encore' ), PM_SOCIAL_ENCORE_PLUGIN_NAME)), 'manage_options', 'pm_social_encore_settings', 'pm_social_encore_settings_page', '' );
	add_action( 'admin_init', 'pm_social_encore_settings_register_callback' );
}
add_action( 'admin_menu', 'pm_social_encore_register_settings_page' );

/*
	* pm_social_encore_settings_register_callback
*/

function pm_social_encore_settings_register_callback() {
	//register our settings
	register_setting( 'pm-social-encore-settings-group', PM_SOCIAL_ENCORE_SETTINGS_OPTION, 'pm_social_encore_settings_validate');
}

/*
	* pm_social_encore_settings_validate
*/

function pm_social_encore_settings_validate($input) {
	$array = array();
	foreach($input as $key => $values) {
		if(is_array($input[$key])) {
			//$input[$key] = array_filter($input[$key]);
			if($input[$key]) {
				//$values = array_filter($values);
				if(is_array($values)){
					foreach($values as $vkey => $value) {
						$array[$key][$vkey] = wp_strip_all_tags($value,true);
					}
				}
			}
			
		}
	}
	return $array;
}

function pm_social_encore_settings_page() {
	
	?>
	<h2><?php esc_html(printf(__( '%s Settings ', 'pm-social-encore' ), PM_SOCIAL_ENCORE_PLUGIN_NAME)); ?></h2>
	<?php	
	// Print Facebook Connection
	pm_social_encore_facebook_connect();
	// Print LinkedIn Connection
	pm_social_encore_linkedin_connect();
	
	$setting_fields = pm_social_encore_setting_fields();
	$options = get_option(PM_SOCIAL_ENCORE_SETTINGS_OPTION, array());
	?>
	<div id="social_encore_settings">
		<form id="pm_social_encore_form" class="pm_social_encore_form" action="options.php" method='post'>
			<?php settings_fields( 'pm-social-encore-settings-group' ); ?>
			<?php do_settings_sections( 'pm-social-encore-settings-group' ); ?>
			<?php foreach($setting_fields as $skey =>  $fields): 
			$visibility = ($options[$skey]['authorized'] ? ' style="display: none;" ' : '');
			?>
			<div <?php print $visibility; ?> id="social_<?php print $skey; ?>">
				<h3><?php print $fields['social_name']; ?></h3>
				<p class="description"><?php print $fields['general_description']; ?></p>
				<div>
					<?php foreach($fields['fields'] as $fkey => $field): 
					$default_value = $setting_fields[$skey]['fields'][$field['name']]['default'];
					$option = (isset($options[$skey][$fkey]) ? $options[$skey][$fkey] : $default_value);
					if(pm_social_encore_set_field('type',$skey,$field['name']) != 'hidden'):
					?>
					<div>
						<label for="<?php print pm_social_encore_set_field('id',$skey,$field['name']); ?>"><?php print $field['label']; ?>:</label><br />
						<p class="description"><span><input type="<?php print pm_social_encore_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_social_encore_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_social_encore_set_field('id',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="social_encore_setting_field" /></span>
						<span><?php print pm_social_encore_set_field('description',$skey,$field['name']); ?></span></p>
					</div>
					<?php else: ?>
					<div>
						<input type="<?php print pm_social_encore_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_social_encore_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_social_encore_set_field('id',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="social_encore_setting_field" />
					</div>
					<?php endif; //Not HIdden ?>
					<?php endforeach; ?>
				</div>
			</div>
			<?php if($options[$skey]['authorized']): ?>
				<div>
				<h3><?php print $fields['social_name']; ?></h3>
				<?php pm_social_encore_social_logout($skey); ?>
				</div>
			<?php endif; ?>
			<?php endforeach; ?>
			<?php submit_button( esc_html(__('Save Settings', 'pm-social-encorer')), 'primary', 'pm_social_encore_submit', false, array('id' => 'pm_social_encore_submit') ); ?>
		</form>
	</div>
<?php
}